Skip to main content
`Ctrl`+`K`

# TSSetForcingFunction

Provide a function that computes a forcing term for a ODE or PDE

## Synopsis

    #include "petscts.h"
    PetscErrorCode TSSetForcingFunction(TS ts, TSForcingFn *func, PetscCtx ctx)

Logically Collective

## Input Parameters

- ts - the `TS` context obtained from `TSCreate()`

- func - routine for evaluating the forcing function

- ctx - [optional] user-defined context for private data for the function evaluation routine (may be `NULL`)

## Notes

This routine is useful for testing accuracy of time integration schemes when using the Method of Manufactured Solutions to create closed-form solutions with a non-physical forcing term. It allows you to use the Method of Manufactored Solution without directly editing the definition of the problem you are solving and hence possibly introducing bugs.

This replaces the ODE F(u,u_t,t) = 0 the `TS` is solving with F(u,u_t,t) - func(t) = 0

This forcing function does not depend on the solution to the equations, it can only depend on spatial location, time, and possibly parameters, the parameters can be passed in the ctx variable.

For low-dimensional problems solved in serial, such as small discrete systems, `TSMonitorLGError()` can be used to monitor the error history.

## See Also

TS: Scalable ODE and DAE Solvers, `TS`, `TSForcingFn`, `TSSetRHSJacobian()`, `TSSetIJacobian()`, `TSComputeSolutionFunction()`, `TSSetSolutionFunction()`

## Level

intermediate

## Location

src/ts/interface/ts.c

Index of all TS routines
Table of Contents for all manual pages
Index of all manual pages